package com.xjrsoft.xjrsoftboot;

import cn.dev33.satoken.secure.SaSecureUtil;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.db.ds.simple.SimpleDataSource;
import cn.hutool.db.meta.Column;
import cn.hutool.db.meta.MetaUtil;
import cn.hutool.db.meta.Table;
import cn.hutool.http.HttpUtil;
import com.baomidou.mybatisplus.core.toolkit.StringPool;
import com.xjrsoft.XjrSoftApplication;
import com.xjrsoft.common.constant.GlobalConstant;
import com.xjrsoft.common.utils.DatasourceUtil;
import com.xjrsoft.common.utils.JdbcToJavaUtil;
import com.xjrsoft.module.generator.constant.EntityConstant;
import com.xjrsoft.module.generator.dto.ApiGenerateCodesDto;
import com.xjrsoft.module.generator.entity.FieldConfig;
import com.xjrsoft.module.generator.entity.GeneratorConfig;
import com.xjrsoft.module.generator.entity.TableConfig;
import com.xjrsoft.module.generator.service.IApiGeneratorService;
import com.xjrsoft.module.generator.service.impl.ApiGeneratorServiceImpl;
import freemarker.template.Template;
import freemarker.template.TemplateException;
import lombok.AllArgsConstructor;
import org.junit.jupiter.api.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.ui.freemarker.FreeMarkerTemplateUtils;
import org.springframework.web.servlet.view.freemarker.FreeMarkerConfigurer;

import javax.sql.DataSource;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.stream.Collectors;

public class FreeMarkerGeneratorTest {

    private static final DataSource ds = new SimpleDataSource("jdbc:mysql://10.150.10.139:3306/tl?useSSL=false&useUnicode=true&characterEncoding=utf-8&zeroDateTimeBehavior=convertToNull&transformedBitIsBoolean=true&serverTimezone=GMT%2B8&nullCatalogMeansCurrent=true",
            "root" , "Zwr~-f6H,u6QE^]C-AD_" );

    @Test
    public void generateCodesTest() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("xjr_oa_news");
        mainTable.setIsMain(true);
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);

        TableConfig childTable1 = new TableConfig();
        childTable1.setTableName("xjr_oa_news_relation");
        childTable1.setIsMain(false);
        childTable1.setPkField(GlobalConstant.DEFAULT_PK);
        childTable1.setPkType(GlobalConstant.DEFAULT_PK_TYPE);
        childTable1.setRelationField("news_id");
        childTable1.setRelationTableField(GlobalConstant.DEFAULT_PK);


        TableConfig childTable2 = new TableConfig();
        childTable2.setTableName("xjr_oa_news_relation_config");
        childTable2.setIsMain(false);
        childTable2.setPkField(GlobalConstant.DEFAULT_PK);
        childTable2.setPkType(GlobalConstant.DEFAULT_PK_TYPE);
        childTable2.setRelationField("news_id");
        childTable2.setRelationTableField(GlobalConstant.DEFAULT_PK);

        tableConfigs.add(mainTable);
        tableConfigs.add(childTable1);
//        tableConfigs.add(childTable2);

        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("fanxp");
        params.setPackageName("test");
        params.setTableConfigs(tableConfigs);
        params.setPage(true);
        params.setImport(true);
        params.setExport(true);
        params.setOutMainDir(true);
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }
    @Test
    public void generateCodesTest1() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("xjr_oa_news");
        mainTable.setIsMain(true);
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);

        TableConfig childTable1 = new TableConfig();
        childTable1.setTableName("xjr_oa_news_relation");
        childTable1.setIsMain(false);
        childTable1.setPkField(GlobalConstant.DEFAULT_PK);
        childTable1.setPkType(GlobalConstant.DEFAULT_PK_TYPE);
        childTable1.setRelationField("news_id");
        childTable1.setRelationTableField(GlobalConstant.DEFAULT_PK);


        TableConfig childTable2 = new TableConfig();
        childTable2.setTableName("xjr_oa_news_relation_config");
        childTable2.setIsMain(false);
        childTable2.setPkField(GlobalConstant.DEFAULT_PK);
        childTable2.setPkType(GlobalConstant.DEFAULT_PK_TYPE);
        childTable2.setRelationField("news_id");
        childTable2.setRelationTableField(GlobalConstant.DEFAULT_PK);

        tableConfigs.add(mainTable);
        tableConfigs.add(childTable1);
//        tableConfigs.add(childTable2);

        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("fanxp");
        params.setPackageName("test");
        params.setTableConfigs(tableConfigs);
        params.setPage(true);
        params.setImport(true);
        params.setExport(true);
        params.setOutMainDir(false);
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }

    @Test
    public void gcMaterialType() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("material_type");
        mainTable.setIsMain(true);
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);

        TableConfig childTable1 = new TableConfig();
        childTable1.setTableName("material_type_assign");
        childTable1.setIsMain(false);
        childTable1.setPkField(GlobalConstant.DEFAULT_PK);
        childTable1.setPkType(GlobalConstant.DEFAULT_PK_TYPE);
        childTable1.setRelationField("material_type_id");
        childTable1.setRelationTableField(GlobalConstant.DEFAULT_PK);

        tableConfigs.add(mainTable);
        tableConfigs.add(childTable1);

        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("baicai");
        params.setPackageName("material");
        params.setTableConfigs(tableConfigs);
        params.setPage(true);
        params.setImport(true);
        params.setExport(true);
        params.setOutMainDir(false);
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }


    @Test
    public void gcMaterialTask() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("material_task");
        mainTable.setIsMain(true);
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);

        TableConfig childTable1 = new TableConfig();
        childTable1.setTableName("material_task_assign");
        childTable1.setIsMain(false);
        childTable1.setPkField(GlobalConstant.DEFAULT_PK);
        childTable1.setPkType(GlobalConstant.DEFAULT_PK_TYPE);
        childTable1.setRelationField("material_task_id");
        childTable1.setRelationTableField(GlobalConstant.DEFAULT_PK);


        TableConfig childTable2 = new TableConfig();
        childTable2.setTableName("material_task_appendix");
        childTable2.setIsMain(false);
        childTable2.setPkField(GlobalConstant.DEFAULT_PK);
        childTable2.setPkType(GlobalConstant.DEFAULT_PK_TYPE);
        childTable2.setRelationField("material_task_id");
        childTable2.setRelationTableField(GlobalConstant.DEFAULT_PK);

        tableConfigs.add(mainTable);
        tableConfigs.add(childTable1);
        tableConfigs.add(childTable2);

        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("baicai");
        params.setPackageName("material");
        params.setTableConfigs(tableConfigs);
        params.setPage(true);
        params.setImport(true);
        params.setExport(true);
        params.setOutMainDir(false);
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }

    @Test
    public void gcLiteFlowTest() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("xjr_liteflow_chain");
        mainTable.setIsMain(true);
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);

        tableConfigs.add(mainTable);

        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("fanxp");
        params.setPackageName("liteflow");
        params.setTableConfigs(tableConfigs);
        params.setPage(false);
        params.setImport(false);
        params.setExport(false);
        params.setOutMainDir(false);
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }

    @Test
    public void gcWFPushTest() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("wf_oa_push");
        mainTable.setIsMain(true);
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);

        tableConfigs.add(mainTable);

        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("fanxp");
        params.setPackageName("oa");
        params.setTableConfigs(tableConfigs);
        params.setPage(false);
        params.setImport(false);
        params.setExport(false);
        params.setOutMainDir(false);
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }

    @Test
    public void gcWFPullest() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("wf_oa_pull");
        mainTable.setIsMain(true);
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);

        tableConfigs.add(mainTable);

        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("fanxp");
        params.setPackageName("oa");
        params.setTableConfigs(tableConfigs);
        params.setPage(false);
        params.setImport(false);
        params.setExport(false);
        params.setOutMainDir(false);
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }

    @Test
    public void gcfileReceiveTest() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("file_receive");
        mainTable.setIsMain(true);
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);

        tableConfigs.add(mainTable);

        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("fanxp");
        params.setPackageName("oa");
        params.setTableConfigs(tableConfigs);
        params.setPage(true);
        params.setImport(false);
        params.setExport(false);
        params.setOutMainDir(true);
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }


    @Test
    public void gcAppWorkflowConfig() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("base_app_function");
        mainTable.setIsMain(true);
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);

        tableConfigs.add(mainTable);

        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("fanxp");
        params.setPackageName("app");
        params.setTableConfigs(tableConfigs);
        params.setPage(false);//是否生成分页接口
        params.setImport(false);//是否生成导入接口
        params.setExport(false);//是否生成导出接口
        params.setOutMainDir(true);//是否生成在主目录，前期测试可设置成false
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }

    @Test
    public void gcBasePersonnelLabourCapital() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("base_personnel_labour_capital");//init_sql中的表名
        mainTable.setIsMain(true);//是否是主表，一般默认为true
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);//设置主键
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);//设置主键类型

        tableConfigs.add(mainTable);

        mainTable = new TableConfig();
        mainTable.setTableName("base_personnel_labour_capital_data");//init_sql中的表名
        mainTable.setIsMain(false);//是否是主表，一般默认为true
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);//设置主键
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);//设置主键类型
        mainTable.setRelationField("labour_capital_id");//设置外键
        mainTable.setRelationTableField(GlobalConstant.DEFAULT_PK);//设置外键

        tableConfigs.add(mainTable);

        mainTable = new TableConfig();
        mainTable.setTableName("base_personnel_labour_capital_title");//init_sql中的表名
        mainTable.setIsMain(false);//是否是主表，一般默认为true
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);//设置主键
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);//设置主键类型
        mainTable.setRelationField("labour_capital_id");//设置外键
        mainTable.setRelationTableField(GlobalConstant.DEFAULT_PK);//设置外键

        tableConfigs.add(mainTable);

        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("dzx");//作者名称
        params.setPackageName("personnel");//包名
        params.setTableConfigs(tableConfigs);
        params.setPage(true);//是否生成分页接口
        params.setImport(true);//是否生成导入接口
        params.setExport(false);//是否生成导出接口
        params.setOutMainDir(true);//是否生成在主目录，前期测试可设置成false
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }

    /**
     * 学生校级干部管理
     */
    @Test
    public void gcBaseStudentSchoolCadre() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("base_student_school_cadre");//init_sql中的表名
        mainTable.setIsMain(true);//是否是主表，一般默认为true
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);//设置主键
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);//设置主键类型

        tableConfigs.add(mainTable);


        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("dzx");//作者名称
        params.setPackageName("student");//包名
        params.setTableConfigs(tableConfigs);
        params.setPage(true);//是否生成分页接口
        params.setImport(false);//是否生成导入接口
        params.setExport(true);//是否生成导出接口
        params.setOutMainDir(true);//是否生成在主目录，前期测试可设置成false
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }


    /**
     * 学生班级干部管理
     */
    @Test
    public void gcBaseStudentClassCadre() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("base_student_class_cadre");//init_sql中的表名
        mainTable.setIsMain(true);//是否是主表，一般默认为true
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);//设置主键
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);//设置主键类型

        tableConfigs.add(mainTable);


        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("dzx");//作者名称
        params.setPackageName("student");//包名
        params.setTableConfigs(tableConfigs);
        params.setPage(true);//是否生成分页接口
        params.setImport(false);//是否生成导入接口
        params.setExport(true);//是否生成导出接口
        params.setOutMainDir(true);//是否生成在主目录，前期测试可设置成false
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }

    /**
     * 快捷菜单
     */
    @Test
    public void gcXjrMenuQuick() throws IOException {
        List<TableConfig> tableConfigs = new ArrayList<>();
        TableConfig mainTable = new TableConfig();
        mainTable.setTableName("xjr_menu_quick");//init_sql中的表名
        mainTable.setIsMain(true);//是否是主表，一般默认为true
        mainTable.setPkField(GlobalConstant.DEFAULT_PK);//设置主键
        mainTable.setPkType(GlobalConstant.DEFAULT_PK_TYPE);//设置主键类型

        tableConfigs.add(mainTable);


        ApiGenerateCodesDto params = new ApiGenerateCodesDto();
        params.setAuthor("fanxp");//作者名称
        params.setPackageName("system");//包名
        params.setTableConfigs(tableConfigs);
        params.setPage(false);//是否生成分页接口
        params.setImport(false);//是否生成导入接口
        params.setExport(false);//是否生成导出接口
        params.setOutMainDir(true);//是否生成在主目录，前期测试可设置成false
        params.setDs(ds);


        IApiGeneratorService apiGeneratorService = new ApiGeneratorServiceImpl();

        apiGeneratorService.generateCodes(params);
    }
}
